;;;Professional Plumbing Design and Construction
;;;Butler Plumbing Company
;;;236A W. East Ave.#161, Chico CA 95926
;;;(916) 898-8465
;;;
;;;Power Pan Ver 3.0 will do a running pan or zoom as long as long as
;;;Ten-Key Arrows or Zoom keys are pressed...i.e.#8=UP #2=DOWN, etc.
;;;To zoom, use Grey Plus [+] key to zoom in and Grey Minus [-] key to zoom out.
;;;Also now available is zoom [W]indow..zoom [V]max and [*] to restore origional view
;;;
;;;Note: This version will not work with Release 13 for Windows.
;;;      Should work with other releases.
;;;
;;;         -
;;; 7  8  9 +
;;;  \ ^ /
;;; 4<   >6
;;;  / v \
;;; 1  2  3
;;;
;;;
;;;
(defun c:pp (/ loop ctr size ex)
(setq test T)
(setq ex (getvar "expert"))
(setvar "expert" 1)
(resetargs)
(command "view" "s" "pp")
(setq loop T)
   (while loop
     (if loop
       (progn                        
         (VECT2)                      
         (setq ctr   (getvar "viewctr")
               size  (/ (getvar "viewsize") (if max 1.25 8))   ;Change this value to increase
         )                                      ;or decrease pan distance
         (if (and loop panit) (command "pan" ctr (polar ctr ang size)))
         (if (and loop zoomm)(command "zoom" "c" ctr (* (getvar "viewsize") 1.25)))
         (if (and loop zoomp)(command "zoom" "c" ctr (* (getvar "viewsize") 0.75)))
         (if (and loop viewr)(command "view" "r" "pp"))
         (if (and loop zoomv)(if (= (getvar "tilemode") 1)(command "zoom" "v")(alert "ZOOM V not available in PAPERSPACE!")))
         (if (and loop zoomw)(progn (prompt "\nPick window...")(command "zoom" "w" pause pause "")))
       );progn
     );if
   );while

(setvar "expert" ex)                    
(resetargs)
(print)(print)
(prompt "\nTo restore origional view, Restore the named view [PP]...")
(princ)
)
(defun GETKEY2 ()
     (setq key t)
     (setq key (last (grread nil 10)))
)
(defun GETDIR2 ()
      (cond
         ((= key 54)  (setq panit T  max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 180)))
         ((= key -7)  (setq panit T   max T zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 180)))
         ((= key 13)  (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq loop nil))
         ((= key 0)   (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq loop nil))
         ((= key -2)  (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 315)))
         ((= key 55)  (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 315)))
         ((= key -6)  (setq panit T   max T zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 0)))
         ((= key 52)  (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 0)))
         ((= key -10) (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 45)))
         ((= key 49)  (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 45)))
         ((= key -5)  (setq panit T   max T zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 90)))
         ((= key 50)  (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 90)))
         ((= key -9)  (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 135)))
         ((= key 51)  (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 135)))
         ((= key -8)  (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 225)))
         ((= key 57)  (setq panit T  max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 225)))
         ((= key -4)  (setq panit T   max T zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 270)))
         ((= key 56)  (setq panit T   max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp nil)(setq ang (dtr 270)))
         ((= key 43)  (setq panit nil max nil zoomv nil zoomw nil viewr nil zoomm nil zoomp T)  (setq ang (dtr 270)))
         ((= key 45)  (setq panit nil max nil zoomv nil zoomw nil viewr nil zoomm T   zoomp nil)(setq ang (dtr 270)))
         ((= key 42)  (setq panit nil max nil zoomv nil zoomw nil viewr T   zoomm nil zoomp nil))
         ((= key 118) (setq panit nil max nil zoomv T   zoomw nil viewr nil zoomm nil zoomp nil))
         ((= key 86)  (setq panit nil max nil zoomv T   zoomw nil viewr nil zoomm nil zoomp nil))
         ((= key 119) (setq panit nil max nil zoomv nil zoomw T   viewr nil zoomm nil zoomp nil))
         ((= key 87 ) (setq panit nil max nil zoomv nil zoomw T   viewr nil zoomm nil zoomp nil))
      )
)
(defun VECT2 ()
(prompt "\n")
(prompt "\n")
(prompt "\n\n\nINCREMENTAL PAN with Ten-Key <||||> FULL PAN with Gray Arrow-Keys...RETURN to QUIT...")
(prompt "\nPlus [+] Zoom in..Minus [-] Zoom out..[V] Vmax..[W] Window..[*] Origional View...")
(GETKEY2)
(GETDIR2)
);defun
(defun dtr (a)
  (* pi (/ a 180.0))
)
(defun resetargs ()
         (setq args
           (list 'ang 
                 'panit
                 'zoomm
                 'zoomp
                 'viewr 
                 'zoomv 
                 'zoomw
                 'key
           )
         )
(foreach n args (set n nil))
)
(prompt "\n\tPower Pan Ver 3.0 by BPC Design now loaded!...Type PP to PAN or ZOOM...")
(prompt "\nButler Plumbing Design...Commercial|Residential Plumbing Design...(916) 898-8465")
(princ)

